GestorDeProyectos/urls.py
from django.conf.urls import url
from django.contrib import admin
from django.urls import path, include
from oauth_app.views import inicio
from django.contrib.auth.views import LogoutView

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', inicio, name='inicio'),
    path('accounts/', include('allauth.urls')),
    path('logout', LogoutView.as_view()),
    path('permisos/', include('oauth_app.urls')),
    path('proyectos/', include('Proyecto.urls')),

    #path denis, esta en mayuscula la P
    #path('Proyecto/', include('Proyecto.urls')),
]

Proyecto/urls.py
from django.urls import path
from .views import *
from Proyecto import views

app_name = 'Proyecto'
urlpatterns = [
    path('', views.index, name='index'),
    path('crear/', views.formCrearProyecto, name='crearProyecto'),
    path('crearRol/<int:id>', views.formCrearRolProyecto, name='crearRolProyecto'),
    path('editarRol/<int:id>', views.formEditarRolProyecto, name='editarRolProyecto'),
    path('verRol/<int:id>', views.formVerRolProyecto, name='verRolProyecto'),
    path('importar/<int:id>', views.listarProyectosRol, name='listarProyectosRol'),
    path('importar/<int:id>/<int:id_proyecto>', views.importarRolesProyectos, name='importarRolesProyectos'),
    path('editar/<int:id>', views.editProyecto, name='editarProyecto'),
    path('eliminar/<int:id>', views.deleteProyecto, name='eliminarProyecto'),
    path('guardarUs/<int:id>', FormularioNewUs, name="guardarUs"),
    path('usuarios/<int:id>', views.listaDeUsuarios, name="listaDeUsuarios"),

    # paths para cambiar el diseño de las pestañas para la vista de un proyecto
    path('ver/UsProyecto/<int:id>', views.UsProyecto, name="UsProyecto"),
    path('ver/DetallesProyecto/<int:id>', views.DetallesProyecto, name="DetallesProyecto"),
    path('ver/MiembrosProyecto/<int:id>', views.MiembrosProyecto, name="MiembrosProyecto"),
    path('ver/RolesProyecto/<int:id>', views.RolesProyecto, name="RolesProyecto"),
    # muestra el productBacklog de un proyecto
    path('ver/SprintProyecto/ListarUsSprintBacklog/<int:id>/<int:idSprint>', views.ListarUsSprintBacklog,
         name="ListarUsSprintBacklog"),
    # Agrega US como Sprint Planning
    path('ver/SprintProyecto/agregarSprintBacklog/<int:id>/<int:idSprint>/<int:idUs>', views.agregarSprintBacklog,
         name="agregarSprintBacklog"),
    # Para creacion de un nuevo sprint
    path('ver/SprintProyecto/Crear/<int:id>', views.CrearSprint, name="CrearSprint"),
    # listar sprint
    path('ver/SprintProyecto/<int:id>', views.ListarSprint, name="ListarSprint"),
    # ruta para verificar las cosas, previo a comenzar el sprint
    path('ver/SprintProyecto/VerificarSprint/<int:id>/<int:idSprint>', views.VerificarSprint, name="VerificarSprint"),

    # Url para agregar miembro a un proyecto (muestra solo los miembros que aun no estan en el proyecto)
    path('agregarMiembro/<int:id>/<int:socialUserId>', views.formCrearMiembro, name="agregarMiembros"),
    # Se muestran los datos del miembro del proyecto (rol y disponibilidad horaria)
    path('verMiembro/<int:id>/<int:miembroId>/<int:userAccId>', views.formVerMiembro, name="verMiembros"),
    # Se muestran los campos editables de un miembro en un proyecto (rol y disponibilidad horaria)
    path('editarMiembro/<int:id>/<int:miembroId>/<int:userAccId>', views.formEditarMiembro, name="editarMiembros"),
    # Boton para eliminar un miembro de un proyecto (rol y disponibilidad horaria)
    path('eliminarMiembro/<int:idProyecto>/<int:miembroId>', views.eliminarMiembroProyecto, name="eliminarMiembros"),

    # Boton para reemplazar un miembro de un proyecto
    path('reemplazarMiembro/<int:idProyecto>/<int:miembroViejoId>/<int:idPP>', views.reemplazarMiembroProyecto,
         name="reemplazarMiembro"),

    # Boton para reemplazar un miembro de un proyecto sin eliminarlo, solo reemplazarlo en una US
    path('reemplazarMiembroEnUS/<int:idProyecto>/<int:idUS>', views.reemplazarMiembroEnUSProyecto,
         name="reemplazarMiembroEnUS"),

    # Se reemplaza al US
    path('cambioDeMiembroAlReemplazarEnUs/<int:idProyecto>/<int:userNuevoId>/<int:idPP>',
         views.cambioDeMiembroAlReemplazarEnUs, name="cambioDeMiembroAlReemplazarEnUs"),

    # Al mostrarse las historias de usuario, se deben reemplazar por otro usuario activo del proyecto, esto posibles ususarios son mostrados con esta url
    path('cambioDeMiembroAlEliminar/<int:idProyecto>/<int:miembroViejoId>/<int:userNuevoId>/<int:idPP>',
         views.cambioDeMiembroAlEliminar, name="cambioDeMiembroAlEliminar"),

    # La ruta 'detalles' en donde mostraremos una página con los detalles de un us o registro
    # aqui se pasan por url el parametro que es el id que se requiere para recuperar un reigstro
    path('ver/detalle/<int:id>', UsDetalle.mostrarDetalle, name='detalle'),

    # La ruta 'actualizar' en donde mostraremos un formulario para actualizar un  registro de la Base de Datos
    # aqui se pasan por url el parametro que es el id que se requiere para recuperar un registro
    path('ver/actualizar/<int:id>', UsActualizar.editar, name='actualizar'),

    # para listar el SPrintBacklog de un sprint en planificacion
    path('ver/SprintProyecto/SprintBacklog/<int:id>/<int:idSprint>', views.ListarSprintBacklog,
         name="ListarSprintBacklog"),

    # para editar una planning poker
    path('ver/SprintProyecto/SprintBacklog/EditarPP/<int:id>/<int:idSprint>/<int:idPP>/<int:idUs>', views.EditarPP,
         name="EditarPlanningPoker"),

    # para quitar un US de un sprintbacklog
    path('ver/SprintProyecto/SprintBacklog/<int:id>/<int:idSprint>/<int:idPP>/<int:idUs>', views.QuitarSprintBacklog,
         name="QuitarSprintBacklog"),

    path('kanban/<int:id>/<int:volver>', views.indexKanban, name="verKanban"),

    # path de PRUEBA
    path('miembroprueba/<int:id>', views.obtenerMiembro),

    # path cuando se desea agregar actividad
    path('kanban/agregarActividad/<int:id>/<int:idSprint>/<int:idUs>/<int:volver>', views.agregarActividad,
         name='agregarActividad'),

    # path para cuando se desea ver el historial de modificaciones
    path('kanban/historialMod/<int:idUs>', views.historialMod, name='historialMod'),

    # path para cuando se desea ver el historial
    path('kanban/historialUs/<int:id>/<int:idUs>/<int:volver>/<int:kanbanvolver>/<int:idSprint>', views.historialUs,
         name='historialUs'),

    # Retorna un json con los datos necesarios para el chart
    path('burndownchartjson/<int:idSprint>', views.burndownChart, name='burndownChartjson'),

    # Despliega el burndown del sprint correspondiente
    path('burndownchart/<int:idSprint>', views.burndownChartIndex, name='burndownChart'),

    # Confirmacion de Finalizar un proyecto
    path('ver/confirmarFinalizarProyecto/<int:id>', views.confirmarFinalizarProyecto,
         name='confirmarFinalizarProyecto'),

    # Finalizar un proyecto, por el ID
    path('ver/finalizarProyecto/<int:id>', views.finalizarProyecto, name='finalizarProyecto'),

    # path para desplegar el resumen cuando se termina un sprint
    path('ver/resumenFinSprint/<int:id>/<int:idSprint>', views.resumenFinSprint, name='resumenFinSprint'),

    # path para terminar el sprint y hacer algunos ajustes en los datos
    path('ver/resumen/<int:id>/<int:idSprint>', views.resumenFinSprint, name='resumenFinSprint'),
    path('SprintProyecto/<int:id>/<int:idSprint>', views.finSprint, name='finSprint'),

    # path para editar una actividad
    path(
        'kanban/historialUs/editar/<int:id>/<int:idSprint>/<int:idUs>/<int:volver>/<int:idActividad>/<int:volverkanban>',
        views.editarActividadUs, name='editarActividadUs'),

    # path para los pdf
    # para listar el Sprint Backlog de un sprint en planificacion
    path('listUserStoryPdf/<int:idSprint>/', views.listUserStoryPdf, name="listUserStoryPdf"),

    # para listar el Product Backlog de un proyecto
    path('listProductBacklogPdf/<int:idProyecto>/', views.listProductBacklogPdf, name="listProductBacklogPdf"),

    # para listar los US del sprint actual de un proyecto
    path('listUsSprintActualPdf/<int:idProyecto>/', views.listUsSprintActualPdf, name="listUsSprintActualPdf"),

    # para ver los miembros de un sprint
    path('miembroSprint/<int:idSprint>/', views.miembroEnSprint, name="miembrosSprint"),

]

Proyecto/models.py
import datetime

from django.db import models

# Create your models here.
from django.db import models
from django.contrib.auth.models import Permission, User, GroupManager
from datetime import date, timezone
from django.contrib.auth.models import Permission, User, GroupManager
from django.utils import *

# Modelos para el modulo de proyecto

# Modelo de Proyecto
from django.utils.datetime_safe import time
from pygments.lexer import default

import Proyecto


def get_name(self):
    return self.first_name + " " + self.last_name + " | " + self.email


User.add_to_class("__str__", get_name)


class Proyectos(models.Model):
    # Lista de Estado que puede tener un Proyecto
    ESTADO = (
        ('P', 'Pendiente'),
        ('E', 'En Curso'),
        ('T', 'Terminado'),
        ('C', 'Cancelado'),
    )

    def __str__(self):
        return self.nombre

    nombre = models.CharField(max_length=150, unique=True)  # Nombre del Proyecto
    fechaInicio = models.DateField()  # Fecha de inicio del Proyecto
    fechaFin = models.DateField(null=True, blank=True)  # Fecha de Fin del Proyecto
    descripcion = models.CharField(max_length=450, null=True, blank=True)  # descripcion del Proyecto

    estado = models.CharField(max_length=12, choices=ESTADO, default='P')  # Estado de un Proyecto

    scrumMaster = models.ForeignKey(User, on_delete=models.RESTRICT)  # Scrum Master del Proyecto


# Modelo de Roles
class Roles(models.Model):
    idProyecto = models.ForeignKey(Proyectos, on_delete=models.RESTRICT)  # Proyecto al que pertence el rol
    nombre = models.CharField(max_length=250)  # Nombre del Rol, ejemplo scrum master
    descripcion = models.CharField(max_length=450)  # Descripcion del Rol

    # Campos de Permisos
    agregarUserStory = models.BooleanField(default=False)
    eliminarUserStory = models.BooleanField(default=False)
    modificarUserStory = models.BooleanField(default=False)
    agregarMiembro = models.BooleanField(default=False)
    modificarMiembro = models.BooleanField(default=False)
    eliminarMiembro = models.BooleanField(default=False)
    crearRol = models.BooleanField(default=False)
    modificarRol = models.BooleanField(default=False)
    eliminarRol = models.BooleanField(default=False)
    crearSprint = models.BooleanField(default=False)
    empezarSprint = models.BooleanField(default=False)
    finalizarSprint = models.BooleanField(default=False)
    agregarSprintBacklog = models.BooleanField(default=False)
    modificarSprintBacklog = models.BooleanField(default=False)

    def __str__(self):
        return self.nombre


# Modelos de Miembros
class miembros(models.Model):
    idUser = models.ForeignKey(User, on_delete=models.RESTRICT)  # Usuario asocicado como miembro a un proyecto
    idProyecto = models.ForeignKey(Proyectos, on_delete=models.RESTRICT)  # Proyecto al que esta asociado el miembro
    idRol = models.ForeignKey(Roles, on_delete=models.RESTRICT, null=True,
                              blank=True)  # Con que tiene asociado el Miembro
    activo = models.BooleanField(default=False)  # Estado del Miembro, si esta Activo == True sino == False

    # carga horaria dentro del proyecto
    lunes = models.FloatField(default=0, null=True, blank=True)
    martes = models.FloatField(default=0, null=True, blank=True)
    miercoles = models.FloatField(default=0, null=True, blank=True)
    jueves = models.FloatField(default=0, null=True, blank=True)
    viernes = models.FloatField(default=0, null=True, blank=True)
    sabado = models.FloatField(default=0, null=True, blank=True)
    domingo = models.FloatField(default=0, null=True, blank=True)

    def __str__(self):
        return self.idUser.first_name + " " + self.idUser.last_name + " | " + self.idUser.email


# Modelo de Historia de Usuario
class userStory(models.Model):
    # Lista de Estado del Proyecto
    ESTADOS = (
        ('N', 'Nuevo'),
        ('PP', 'En Planning Pocker'),
        ('P', 'Pendiente'),
        ('EP', 'En Proceso'),
        ('STSA', 'Sin Terminar Sprint Anterior'),
        ('A', 'Aprobado'),
        ('H', 'Hecho'),
        ('C', 'Cancelado'),
    )

    idProyecto = models.ForeignKey(Proyectos, on_delete=models.RESTRICT)  # Proyecto al que perteneces el US
    titulo = models.CharField(max_length=150)  # Titulo del US
    descripcion = models.CharField(max_length=450, null=True, blank=True)  # Descripcion del US

    estado = models.CharField(max_length=4, choices=ESTADOS, default='N')

    fechaIngreso = models.DateField(("Date"), default=date.today)

    # estado = models.IntegerField( default=1)  # Estado del US

    estimacion = models.FloatField(null=True, blank=True)  # Estimacion del US, (en Horas)
    tiempoDedicado = models.FloatField(default=0)  # Tiempo Dedicado al US, (en Horas)

    prioridad = models.IntegerField(null=True, blank=True)  # Prioridad del US, del 1 al 5
    encargado = models.ForeignKey(User, on_delete=models.RESTRICT, null=True,
                                  blank=True)  # Miembro encargado en trabajar el US


# Modelo de Sprint
class Sprint(models.Model):
    ESTADOS = (
        ('P', 'Pendiente'),
        ('E', 'En Curso'),
        ('T', 'Terminado'),
        ('C', 'Cancelado'),
    )

    idProyecto = models.ForeignKey(Proyectos, on_delete=models.RESTRICT)  # Proyecto al que perteneces el Sprint
    numero = models.IntegerField()  # numero de Sprint
    fechaInicio = models.DateField(null=True)  # Fecha de inicio del Sprint
    fechaFin = models.DateField(null=True)  # Fecha de inicio del Sprint
    estado = models.CharField(max_length=1, choices=ESTADOS, default='P')

    def __str__(self):
        return str(self.id)


# VERIFICAR CON EL RESTO QUE ESTE BIEN
class PlanningPoker(models.Model):
    ESTADOS = (
        ('N', 'Nuevo'),
        ('PP', 'En Planning Pocker'),
        ('P', 'Pendiente'),
        ('EP', 'En Proceso'),
        ('STSA', 'Sin Terminar Sprint Anterior'),
        ('A', 'Aprobado'),
        ('H', 'Hecho'),
        ('C', 'Cancelado'),
    )

    estimacionSM = models.FloatField()  # Estimacion en horas
    estimacionEncargado = models.FloatField(blank=True, null=True)  # Estimacion en horas
    estimacionFinal = models.FloatField(blank=True, null=True)
    prioridad = models.IntegerField()
    # miembroSM = models.ForeignKey(miembros, on_delete=models.RESTRICT)
    estado = models.CharField(max_length=4, choices=ESTADOS, default='N')
    miembroEncargado = models.ForeignKey(miembros,
                                         on_delete=models.RESTRICT)  # Al definirse debe de tener un encargado si o si
    idUs = models.ForeignKey(userStory, on_delete=models.RESTRICT)
    idSprint = models.ForeignKey(Sprint, on_delete=models.RESTRICT)  # Debe pertenecer a un sprintPlanning#o idSprint


# modelo para el "historial" de un Us
class ActividadUs(models.Model):
    # hora y fecha en que se registra una nueva actividad relacionada a la US
    fecha = models.DateField(default=timezone.now)
    # le quito de momento el campo hora
    # hora = models.TimeField(default=datetime.time)
    # descripcion del trabajo realizado sobre la US
    detalle = models.CharField(max_length=500)
    # tiempo dedicado al trabajo sobre la US
    duracion = models.FloatField()
    # miembro que realiza la actividad
    idMiembro = models.ForeignKey(miembros, on_delete=models.RESTRICT)
    # sobre que US se realiza la actividad
    idUs = models.ForeignKey(userStory, on_delete=models.RESTRICT)
    # en que sprint se realizo la actividad
    # hago que pueda ser null porque hay actividades que se deben registrar y no necesariamente estan dentro de un sprint, le doy un valor 0 al id en esos casos
    idSprint = models.ForeignKey(Sprint, on_delete=models.RESTRICT, null=True)

class HistorialModificacion(models.Model):
    #detalle, texto predefinido para saber que se realizo
    detalle = models.CharField(max_length=500)
    # US al que se hace refrencia
    idUs = models.ForeignKey(userStory, on_delete=models.RESTRICT)
    #el miembro que realiza el cambio, ya sea de estado u otro tipo de cambio
    idMiembro = models.ForeignKey(miembros, on_delete=models.RESTRICT)
    #fecha
    fecha = models.DateField(default=timezone.now)
    #hora
    hora = models.TimeField(default=datetime.time)

templates/Proyecto/Miembro/crearMiembro.html
{% extends 'base.html' %}
{% load crispy_forms_tags %}
{% block nav-proyecto %}
    <li class="nav-item active">
        <a class="nav-link" href="{% url 'Proyecto:index' %}">Proyecto <span class="sr-only">(current)</span> </a>
    </li>
{% endblock %}
{% block content %}
    {% if form.errors %}
        <div class="alert alert-danger" role="alert">
            ERROR AL GUARDAR
        </div>
    {% endif %}
    <div class="container mb-5">
        <div class="py-5 text-center ">
            <h1 class="text-light"> Agregar <Miembros></Miembros> </h1>
        </div>
        <!-- escribir aqui -->
        <div class="bg-light border rounded border-dark p-3">

            <div class="d-flex align-items-center p-3 my-3 text-dark-50">
                <div>
                    <h6 class="mb-0 lh-100">Miembro: {{ Usuario.first_name }} {{ Usuario.last_name }} </h6>
                    <small>{{ Usuario.email }}</small>
                </div>
            </div>

            <form method="POST">
                {{ formMiembroProyecto|crispy }}
                <button type="submit" class="btn btn-primary">Guardar</button>
                <a class="btn btn-secondary" href="{% url 'Proyecto:listaDeUsuarios' idProyecto %}"
                   role="button">Cancelar</a>
                {% csrf_token %}
            </form>
        </div>
    </div>
{% endblock %}

templates/Proyecto/Miembro/editMiembro.html
{% extends 'base.html' %}
{% load crispy_forms_tags %}
{% block nav-proyecto %}
    <li class="nav-item active">
        <a class="nav-link" href="{% url 'Proyecto:index' %}">Proyecto <span class="sr-only">(current)</span> </a>
    </li>
{% endblock %}
{% block content %}
    {% if form.errors %}
        <div class="alert alert-danger" role="alert">
            ERROR AL GUARDAR
        </div>
    {% endif %}
    <div class="container mb-5">
        <div class="py-5 text-center ">
            <h1 class="text-light"> Editar Miembro
                <Miembros></Miembros>
            </h1>
        </div>

        <div class="bg-light border rounded border-dark p-3">

            <div class="d-flex align-items-center p-3 my-3 text-dark-50">
                <div>
                    <h6 class="mb-0 lh-100">Miembro: {{ Usuario.first_name }} {{ Usuario.last_name }} </h6>
                    <small>{{ Usuario.email }}</small>
                </div>
            </div>

            <form method="POST">
                {{ formEditarMiembroProyecto|crispy }}
                <button type="submit" class="btn btn-primary">Guardar</button>
                <a class="btn btn-secondary" href="{% url 'Proyecto:MiembrosProyecto' idProyecto %}"
                   role="button">Atras</a>
                {% csrf_token %}
            </form>
        </div>
    </div>
{% endblock %}

templates/Proyecto/Miembro/listarUsuarios.html
{% extends 'base.html' %}
{% load custom_tags %}
{% block nav-proyecto %}
    <li class="nav-item active">
        <a class="nav-link" href="{% url 'Proyecto:index' %}">Proyecto <span class="sr-only">(current)</span> </a>
    </li>
{% endblock %}
{% block content %}

    <div class="container mb-5">
        <div class="py-5 text-center ">
            <h1 class="text-light"> Lista de Usuarios </h1>
        </div>
        <div class="bg-light border rounded border-dark ">

            <div class="input-group">
                <input type="text" id="buscarUsuario" onkeyup="buscarTabla('buscarUsuario','tablaUsuario')"
                       placeholder="Buscar por nombre"
                       title="Type in a name" class="form-control m-3" aria-describedby="inputGroup-sizing-lg">
                <a class="btn btn-outline-secondary m-3" type="button"
                   href="{% url 'Proyecto:MiembrosProyecto' idProyecto %}">Volver</a>
            </div>

            <table class="table table-hover" id="tablaUsuario">
                <thead class="thead-dark">
                <tr>
                    <th scope="col">#</th>
                    <th scope="col">Nombre</th>
                    <th scope="col">Apellido</th>
                    <th scope="col">Correo electronico</th>
                    <th scope="col">Acción</th>
                </tr>
                </thead>
                <tbody>
                {% if listaDeUsarios %}
                    {% for u in listaDeUsarios %}
                        {% if not u|esMiembroEnProyecto:idProyecto %}
                            <tr>
                                <th scope="row">{{ u.id }}</th>
                                <td>{{ u.extra_data.given_name }}</td>
                                <td>{{ u.extra_data.family_name }}</td>
                                <td>{{ u.extra_data.email }}</td>
                                <td><a href="{% url 'Proyecto:agregarMiembros' idProyecto u.id %}">Agregar a
                                    proyecto</a>
                            </tr>
                        {% endif %}
                    {% endfor %}
                {% else %}

                {% endif %}
                </tbody>

            </table>

        </div>
    </div>
{% endblock %}

templates/Proyecto/Miembro/listaruserUS.html
{% extends 'base.html' %}
{% load crispy_forms_tags %}
{% block content %}
    <div class="container">
        <br>
        <br>
        <div class="bg-light rounded border-dark p-3">
            <h3>Sprint Backlog</h3>
            <table class="table table-bordered ">
                <thead>
                <tr>
                    <th scope="col">User Story</th>
                    <th scope="col">Prioridad</th>
                    <th scope="col">Estimacion</th>
                    <th scope="col">Estado US</th>
                    <th scope="col">Estado Sprint</th>
                    <th scope="col">Encargado</th>
                    <th scope="col">Acciones</th>
                </tr>
                </thead>
                <tbody>
                {% for pp in listaUSporUser %}
                    <tr>
                        <td>{{ pp.idUs.titulo }}</td>
                        <td>{{ pp.prioridad }}</td>
                        <td>
                            {% if pp.estimacionFinal %}
                                {{ pp.estimacionFinal }}
                            {% else %}
                                No Estimado
                            {% endif %}
                        </td>
                        <td>{{ pp.idUs.estado }}</td>
                        <td>{{ pp.idSprint.estado }}</td>
                        <td>{{ pp.miembroEncargado }}</td>
                        <td>
                                <div class="btn-group">
                                    <a class="btn btn-secondary" href="{% url 'Proyecto:reemplazarMiembro' idProyecto miembroPorEliminarId pp.id %}"
                                       role="button">Reemplazar</a>
                                </div>

                        </td>
                    </tr>
                {% endfor %}
                </tbody>
            </table>


            <div class="bg-light border rounded border-light">
                <a class="btn btn-secondary" href="{% url 'Proyecto:MiembrosProyecto' idProyecto %}"
                   role="button">Volver</a>

            </div>
        </div>
    </div>
{% endblock %}

templates/Proyecto/Miembro/reemplazarUsuario.html
{% extends 'base.html' %}
{% load custom_tags %}
{% block nav-proyecto %}
    <li class="nav-item active">
        <a class="nav-link" href="{% url 'Proyecto:index' %}">Proyecto <span class="sr-only">(current)</span> </a>
    </li>
{% endblock %}
{% block content %}
    <div class="container mb-5">
        <div class="py-5 text-center ">
            <h1 class="text-light"> Lista de Usuarios para Reemplazar</h1>
        </div>

        <div class="bg-light border rounded border-dark ">

            <div class="input-group">
                <input type="text" id="buscarUsuario" onkeyup="buscarTabla('buscarUsuario','tablaUsuario')"
                       placeholder="Buscar por nombre"
                       title="Type in a name" class="form-control m-3" aria-describedby="inputGroup-sizing-lg">
                <a class="btn btn-outline-secondary m-3" type="button"
                   href="{% url 'Proyecto:eliminarMiembros' idProyecto miembroPorEliminarId %}">Volver</a>

            </div>
            <div class="alert alert-warning d-flex align-items-center" role="alert">
                <svg class="bi flex-shrink-0 me-2" width="24" height="24" role="img" aria-label="Warning:">
                    <use xlink:href="#exclamation-triangle-fill"/>
                </svg>
                <div>
                    Observación : Solo apareceran miembros del proyecto que esten activos.
                </div>
            </div>
            <table class="table table-hover" id="tablaUsuario">
                <thead class="thead-dark">
                <tr>
                    <th scope="col">#</th>
                    <th scope="col">Nombre</th>
                    <th scope="col">Apellido</th>
                    <th scope="col">Correo electronico</th>
                    <th scope="col">Acción</th>
                </tr>
                </thead>
                <tbody>
                {% if listaDeUsarios %}
                    {% for u in listaDeUsarios %}
                        {% if u|esMiembroElegible:idProyecto %}
                            {% if not u|esEsteMiembro:miembroPorEliminar %}
                                <tr>
                                    <th scope="row">{{ u.id }}</th>
                                    <td>{{ u.extra_data.given_name }}</td>
                                    <td>{{ u.extra_data.family_name }}</td>
                                    <td>{{ u.extra_data.email }}</td>
                                    <td>

                                        <form method="POST" action="">
                                            {% csrf_token %}
                                            <div class="btn-group">
                                                <a href="{% url 'Proyecto:cambioDeMiembroAlEliminar' idProyecto miembroPorEliminarId u.user_id PP.id %}" role="button">Reemplazar</a>
                                            </div>
                                        </form>
                                    </td>
                                </tr>
                            {% endif %}
                        {% endif %}
                    {% endfor %}
                {% endif %}
                </tbody>

            </table>
        </div>
    </div>
{% endblock %}

templates/Proyecto/Miembro/verMiembro.html
{% extends 'base.html' %}
{% load crispy_forms_tags %}
{% block nav-proyecto %}
    <li class="nav-item active">
        <a class="nav-link" href="{% url 'Proyecto:index' %}">Proyecto <span class="sr-only">(current)</span> </a>
    </li>
{% endblock %}
{% block content %}
    {% if form.errors %}
        <div class="alert alert-danger" role="alert">
            ERROR AL GUARDAR
        </div>
    {% endif %}
    <div class="container mb-5">


        <div class="py-5 text-center ">
            <h1 class="text-light"> Ver Miembro
                <Miembros></Miembros>
            </h1>
        </div>

        <div class="bg-light border rounded border-dark p-3">

            <div class="d-flex align-items-center p-3 my-3 text-dark-50">
                <!--
                <img class="mr-3" src="{{ Usuario.extra_data.picture }}" width="48" height="48">
                -->
                <div>
                    <h6 class="mb-0 lh-100">Miembro: {{ Usuario.first_name }} {{ Usuario.last_name }} </h6>
                    <small>{{ Usuario.email }}</small>
                </div>
            </div>

            <form method="POST">
                {{ formMiembroProyecto|crispy }}
                <a class="btn btn-secondary" href="{% url 'Proyecto:MiembrosProyecto' idProyecto %}"
                   role="button">Atras</a>
            </form>
        </div>
    </div>
{% endblock %}